---
title: Drag Operations
slug: Web/API/HTML_Drag_and_Drop_API/Drag_operations
tags:
  - Advanced
  - Guide
  - HTML
  - HTML5
  - drag and drop
---
<p>{{DefaultAPISidebar("HTML Drag and Drop API")}}</p>

<p>The following describes the steps that occur during a drag and drop operation.</p>

<p class="note">The drag operations described in this document use the {{domxref("DataTransfer")}} interface. This document does <em>not</em> use the {{domxref("DataTransferItem")}} interface nor the {{domxref("DataTransferItemList")}} interface.</p>

<h2 id="draggableattribute">The <code>draggable</code> Attribute</h2>

<p>In a web page, there are certain cases where a default drag behavior is used. These include text selections, images, and links. When an image or link is dragged, the URL of the image or link is set as the drag data, and a drag begins. For other elements, they must be part of a selection for a default drag to occur. To see this in effect, select an area of a webpage, and then click and hold the mouse and drag the selection. An OS-specific rendering of the selection will appear and follow the mouse pointer as the drag occurs. However, this behavior is only the default drag behavior, if no listeners adjust the data to be dragged.</p>

<p>In HTML, apart from the default behavior for images, links, and selections, no other elements are draggable by default.</p>

<p>To make other HTML elements draggable, three things must be done:</p>

<ol>
	<li>Set the <code>{{htmlattrxref("draggable")}}="</code><code>true"</code> on the element that you wish to make draggable.</li>
	<li>Add a listener for the <code>{{event("dragstart")}}</code> event.</li>
	<li><a href="/en-US/docs/Web/API/DataTransfer/setData">Set the drag data</a> in the above listener.</li>
</ol>

<p>Here is an example which allows a section of content to be dragged.</p>

<pre class="brush: html">&lt;p draggable="true" ondragstart="event.dataTransfer.setData('text/plain', 'This text may be dragged')"&gt;
  This text &lt;strong&gt;may&lt;/strong&gt; be dragged.
&lt;/p&gt;
</pre>

<p>The <code>{{htmlattrxref("draggable")}}</code> attribute is set to <code>"true"</code>, so this element becomes draggable. If this attribute were omitted or set to <code>"false"</code>, the element would not be dragged, and instead the text would be selected.</p>

<p>The <code>{{htmlattrxref("draggable")}}</code> attribute may be used on any element, including images and links. However, for these last two, the default value is <code>true</code>, so you would only use the <code>{{htmlattrxref("draggable")}}</code> attribute with a value of <code>false</code> to disable dragging of these elements.</p>

<div class="notecard note">
<p><strong>Note:</strong> When an element is made draggable, text or other elements within it can no longer be selected in the normal way by clicking and dragging with the mouse. Instead, the user must hold down the <kbd>Alt</kbd> key to select text with the mouse, or use the keyboard.</p>
</div>

<h2 id="dragstart">Starting a Drag Operation</h2>

<p>In this example, a listener is added for the {{event("dragstart")}} event by using the <code>{{domxref("GlobalEventHandlers.ondragstart","ondragstart")}}</code> attribute.</p>

<pre class="brush: html">&lt;p draggable="true" ondragstart="event.dataTransfer.setData('text/plain', 'This text may be dragged')"&gt;
  This text &lt;strong&gt;may&lt;/strong&gt; be dragged.
&lt;/p&gt;
</pre>

<p>When a user begins to drag, the {{event("dragstart")}} event is fired.</p>

<p>In this example the {{event("dragstart")}} listener is added to the draggable element itself. however, you could listen to a higher ancestor as drag events bubble up as most other events do.</p>

<p>Within the {{event("dragstart")}} event, you can specify the <strong>drag data</strong>, the <strong>feedback image</strong>, and the <strong>drag effects</strong>, all of which are described below. However, only the <strong>drag data</strong> is required. (The default image and drag effects are suitable in most situations.)</p>

<h2 id="dragdata">Drag Data</h2>

<p>All {{domxref("DragEvent","drag events")}} have a property called {{domxref("DragEvent.dataTransfer","dataTransfer")}} which holds the drag data (<code>dataTransfer</code> is a {{domxref("DataTransfer")}} object).</p>

<p>When a drag occurs, data must be associated with the drag which identifies <em>what</em> is being dragged. For example, when dragging the selected text within a textbox, the data associated with the <em>drag data item</em> is the text itself. Similarly, when dragging a link on a web page, the drag data item is the link's URL.</p>

<p>The {{domxref("DataTransfer","drag data")}} contains two pieces of information, the <strong>type</strong> (or format) of the data, and the data's <strong>value</strong>. The format is a type string (such as <code><a href="/en-US/docs/DragDrop/Recommended_Drag_Types#text" title="text/plain">text/plain</a></code> for text data), and the value is a string of text. When the drag begins, you add data by providing a type and the data. During the drag, in an event listener for the <code>{{event("dragenter")}}</code> and <code>{{event("dragover")}}</code> events, you use the data types of the data being dragged to check whether a drop is allowed. For instance, a drop target that accepts links would check for the type <code><a href="/en-US/docs/DragDrop/Recommended_Drag_Types#link" title="text/uri-list">text/uri-list</a></code>. During a drop event, a listener would retrieve the data being dragged and insert it at the drop location.</p>

<p>The {{domxref("DataTransfer","drag data's")}} {{domxref("DataTransfer.types","types")}} property returns a list of MIME-type like {{domxref("DOMString")}}s, such as <code><a href="/en-US/docs/DragDrop/Recommended_Drag_Types#text" title="text/plain">text/plain</a></code> or <code><a href="/en-US/docs/DragDrop/Recommended_Drag_Types#image" title="image/jpeg">image/jpeg</a></code>. You can also create your own types. The most commonly used types are listed in the article <a href="/en-US/docs/DragDrop/Recommended_Drag_Types">Recommended Drag Types</a>.</p>

<p>A drag may include data items of several different types. This allows data to be provided in more specific types, often custom types, yet still provide fallback data for drop targets that do not support more specific types. It is usually the case that the least specific type will be normal text data using the type <code><a href="/en-US/docs/DragDrop/Recommended_Drag_Types#text" title="text/plain">text/plain</a></code>. This data will be a simple textual representation.</p>

<p>To set a drag data item within the {{domxref("DragEvent.dataTransfer","dataTransfer")}}, use the {{domxref("DataTransfer.setData","setData()")}} method. It takes two arguments: the type of data and the data value. For example:</p>

<pre class="brush: js">event.dataTransfer.setData("text/plain", "Text to drag");
</pre>

<p>In this case, the data value is "Text to drag" and is of the format <code><a href="/en-US/docs/DragDrop/Recommended_Drag_Types#text" title="text/plain">text/plain</a></code>.</p>

<p>You can provide data in multiple formats. To do this, call the {{domxref("DataTransfer.setData","setData()")}} method multiple times with different formats. You should call it with formats in order from most specific to least specific.</p>

<pre class="brush: js">const dt = event.dataTransfer;
dt.setData("application/x.bookmark", bookmarkString);
dt.setData("text/uri-list", "https://www.mozilla.org");
dt.setData("text/plain", "https://www.mozilla.org");
</pre>

<p>Here, data is added in three different types. The first type, <code>application/x.bookmark</code>, is a custom type. Other applications won't support this type, but you can use a custom type for drags between areas of the same site or application.</p>

<p>By providing data in other types as well, we can also support drags to other applications in less specific forms. The <code>application/x.bookmark</code> type can provide data with more details for use within the application whereas the other types can include just a single URL or text version.</p>

<p>Note that both the <code><a href="/en-US/docs/DragDrop/Recommended_Drag_Types#link" title="text/uri-list">text/uri-list</a></code> and <code><a href="/en-US/docs/DragDrop/Recommended_Drag_Types#text" title="text/plain">text/plain</a></code> contain the same data in this example. This will often be true, but doesn't need to be the case.</p>

<p>If you attempt to add data twice with the same format, the new data will replace the old data, but in the same position within the list of types as the old data.</p>

<p>You can clear the data using the {{domxref("DataTransfer.clearData","clearData()")}} method, which takes one argument: the type of the data to remove.</p>

<pre class="brush: js">event.dataTransfer.clearData("text/uri-list");
</pre>

<p>The <code>type</code> argument to the {{domxref("DataTransfer.clearData","clearData()")}} method is optional. If the <code>type</code> is not specified, the data associated with all types is removed. If the drag contains no drag data items, or all of the items have been subsequently cleared, then no drag will occur.</p>

<h2 id="dragfeedback">Setting the drag feedback image</h2>

<p>When a drag occurs, a translucent image is generated from the drag target (the element the "{{event("dragstart")}}" event is fired at), and follows the user's pointer during the drag. This image is created automatically, so you do not need to create it yourself. However, you can use {{domxref("DataTransfer.setDragImage","setDragImage()")}} to specify a custom drag feedback image.</p>

<pre class="brush: js">event.dataTransfer.setDragImage(image, xOffset, yOffset);
</pre>

<p>Three arguments are necessary. The first is a reference to an image. This reference will typically be to an <code>&lt;img&gt;</code> element, but it can also be to a <code>&lt;canvas&gt;</code> or any other element. The feedback image will be generated from whatever the image looks like on screen, although for images, they will be drawn at their original size. The second and third arguments to the {{domxref("DataTransfer.setDragImage","setDragImage()")}} method are offsets where the image should appear relative to the mouse pointer.</p>

<p>It is also possible to use images and canvases that are not in a document. This technique is useful when drawing custom drag images using the canvas element, as in the following example:</p>

<pre class="brush: js">function dragWithCustomImage(event) {
  const canvas = document.createElement("canvas");
  canvas.width = canvas.height = 50;

  const ctx = canvas.getContext("2d");
  ctx.lineWidth = 4;
  ctx.moveTo(0, 0);
  ctx.lineTo(50, 50);
  ctx.moveTo(0, 50);
  ctx.lineTo(50, 0);
  ctx.stroke();

  const dt = event.dataTransfer;
  dt.setData('text/plain', 'Data to Drag');
  dt.setDragImage(canvas, 25, 25);
}
</pre>

<p>In this example, we make one canvas the drag image. As the canvas is <code>50</code>×<code>50</code> pixels, we use offsets of half of this (<code>25</code>) so that the image appears centered on the mouse pointer.</p>

<h2 id="drageffects">Drag Effects</h2>

<p>When dragging, there are several operations that may be performed. The <code>copy</code> operation is used to indicate that the data being dragged will be copied from its present location to the drop location. The <code>move</code> operation is used to indicate that the data being dragged will be moved, and the <code>link</code> operation is used to indicate that some form of relationship or connection will be created between the source and drop locations.</p>

<p>You can specify which of the three operations are allowed for a drag source by setting the {{domxref("DataTransfer.effectAllowed","effectAllowed")}} property within a <code>{{event("dragstart")}}</code> event listener.</p>

<pre class="brush: js">event.dataTransfer.effectAllowed = "copy";
</pre>

<p>In this example, only a <strong>copy</strong> is allowed.</p>

<p>You can combine the values in various ways:</p>

<dl>
	<dt><code>none</code></dt>
	<dd>no operation is permitted</dd>
	<dt><code>copy</code></dt>
	<dd><code>copy</code> only</dd>
	<dt><code>move</code></dt>
	<dd><code>move</code> only</dd>
	<dt><code>link</code></dt>
	<dd><code>link</code> only</dd>
	<dt><code>copyMove</code></dt>
	<dd><code>copy</code> or <code>move</code> only</dd>
	<dt><code>copyLink</code></dt>
	<dd><code>copy</code> or <code>link</code> only</dd>
	<dt><code>linkMove</code></dt>
	<dd><code>link</code> or <code>move</code> only</dd>
	<dt><code>all</code></dt>
	<dd><code>copy</code>, <code>move</code>, or <code>link</code></dd>
	<dt>uninitialized</dt>
	<dd>The default value is <code>all</code>.</dd>
</dl>

<p>Note that these values must be used exactly as listed above. For example, setting the {{domxref("DataTransfer.effectAllowed","effectAllowed")}} property to <code>copyMove</code> allows a copy or move operation but prevents the user from performing a link operation. If you don't change the {{domxref("DataTransfer.effectAllowed","effectAllowed")}} property, then any operation is allowed, just like with the '<code>all</code>' value. So you don't need to adjust this property unless you want to exclude specific types.</p>

<p>During a drag operation, a listener for the <code>{{event("dragenter")}}</code> or <code>{{event("dragover")}}</code> events can check the {{domxref("DataTransfer.effectAllowed","effectAllowed")}} property to see which operations are permitted. A related property, {{domxref("DataTransfer.dropEffect","dropEffect")}}, should be set within one of these events to specify which single operation should be performed. Valid values for {{domxref("DataTransfer.dropEffect","dropEffect")}} are <code>none</code>, <code>copy</code>, <code>move</code>, or <code>link</code>. The combination values are not used for this property.</p>

<p>With the <code>{{event("dragenter")}}</code> and <code>{{event("dragover")}}</code> event, the {{domxref("DataTransfer.dropEffect","dropEffect")}} property is initialized to the effect that the user is requesting. The user can modify the desired effect by pressing modifier keys. Although the exact keys used vary by platform, typically the <kbd>Shift</kbd> and <kbd>Control</kbd> keys would be used to switch between copying, moving, and linking. The mouse pointer will change to indicate which operation is desired. For instance, for a <code>copy</code>, the cursor might appear with a plus sign next to it.</p>

<p>You can modify the {{domxref("DataTransfer.dropEffect","dropEffect")}} property during the <code>{{event("dragenter")}}</code> or <code>{{event("dragover")}}</code> events, if for example, a particular drop target only supports certain operations. You can modify the {{domxref("DataTransfer.dropEffect","dropEffect")}} property to override the user effect, and enforce a specific drop operation to occur. Note that this effect must be one listed within the {{domxref("DataTransfer.effectAllowed","effectAllowed")}} property. Otherwise, it will be set to an alternate value that is allowed.</p>

<pre class="brush: js">event.dataTransfer.dropEffect = "copy";
</pre>

<p>In this example, copy is the effect that is performed.</p>

<p>You can use the value <code>none</code> to indicate that no drop is allowed at this location, although it is preferred not to cancel the event in this case.</p>

<p>Within the <code>{{event("drop")}}</code> and <code>{{event("dragend")}}</code> events, you can check the {{domxref("DataTransfer.dropEffect","dropEffect")}} property to determine which effect was ultimately chosen.  If the chosen effect were "<code>move</code>", then the original data should be removed from the source of the drag within the <code>{{event("dragend")}}</code> event.</p>

<h2 id="droptargets">Specifying Drop Targets</h2>

<p>A listener for the <code>{{event("dragenter")}}</code> and <code>{{event("dragover")}}</code> events are used to indicate valid drop targets, that is, places where dragged items may be dropped. Most areas of a web page or application are not valid places to drop data. Thus, the default handling of these events is not to allow a drop.</p>

<p>If you want to allow a drop, you must prevent the default handling by cancelling both the <code>dragenter</code> and <code>dragover</code> events. You can do this either by returning <code>false</code> from attribute-defined event listeners, or by calling the event's {{domxref("Event.preventDefault","preventDefault()")}} method. The latter may be more feasible in a function defined in a separate script.</p>

<pre class="brush: html">&lt;div ondragover="return false"&gt;
&lt;div ondragover="event.preventDefault()"&gt;
</pre>

<p>Calling the {{domxref("Event.preventDefault","preventDefault()")}} method during both a <code>{{event("dragenter")}}</code> and <code>{{event("dragover")}}</code> event will indicate that a drop is allowed at that location. However, you will commonly wish to call the {{domxref("Event.preventDefault","preventDefault()")}} method only in certain situations (for example, only if a link is being dragged).</p>

<p>To do this, call a function which checks a condition and only cancels the event when the condition is met. If the condition is not met, don't cancel the event, and a drop will not occur there if the user releases the mouse button.</p>

<p>It is most common to accept or reject a drop based on the type of drag data in the data transfer — for instance, allowing images, or links, or both. To do this, you can check the {{domxref("DataTransfer.types","types")}} property of the event's {{domxref("DragEvent.dataTransfer","dataTransfer")}} (property). The {{domxref("DataTransfer.types","types")}} property returns an array of the string types that were added when the drag began, in the order from most significant to least significant.</p>

<pre class="brush: js">function doDragOver(event) {
  const isLink = event.dataTransfer.types.includes("text/uri-list");
  if (isLink) {
    event.preventDefault();
  }
}</pre>

<p>In this example, we use the <code>includes</code> method to check if the type <code><a href="/en-US/docs/DragDrop/Recommended_Drag_Types#link" title="text/uri-list">text/uri-list</a></code> is present in the list of types. If it is, we will cancel the event so that a drop may be allowed. If the drag data does not contain a link, the event will not be cancelled, and a drop cannot occur at that location.</p>

<p>You may also wish to set either the {{domxref("DataTransfer.effectAllowed","effectAllowed")}}, {{domxref("DataTransfer.dropEffect","dropEffect")}} property, or both at the same time, if you wish to be more specific about the type of operation that will performed. Naturally, changing either property will have no effect if you do not cancel the event as well.</p>

<h2 id="dropfeedback">Drop Feedback</h2>

<p>There are several ways in which you can indicate to the user that a drop is allowed at a certain location. The mouse pointer will update as necessary depending on the value of the {{domxref("DataTransfer.dropEffect","dropEffect")}} property.</p>

<p>Although the exact appearance depends on the user's platform, typically a plus sign icon will appear for a '<code>copy</code>' for example, and a 'cannot drop here' icon will appear when a drop is not allowed. This mouse pointer feedback is sufficient in many cases.</p>

<p>However, you can also update the user interface with an insertion point or highlight as needed. For simple highlighting, you can use the <code>:-moz-drag-over</code> CSS pseudoclass on a drop target.</p>

<pre class="brush: css">.droparea:-moz-drag-over {
  outline: 1px solid black;
}
</pre>

<p>In this example, the element with the class <code>droparea</code> will receive a 1 pixel black outline while it is a valid drop target, that is, if the {{domxref("Event.preventDefault","preventDefault()")}} method was called during the <code>{{event("dragenter")}}</code> event.</p>

<div class="notecard note">
<p><strong>Note:</strong> You must cancel the <code>{{event("dragenter")}}</code> event for this pseudoclass to apply, as this state is not checked for the <code>{{event("dragover")}}</code> event.</p>
</div>

<p>For more complex visual effects, you can also perform other operations during the <code>{{event("dragenter")}}</code> event. For example, by inserting an element at the location where the drop will occur. This might be an insertion marker, or an element that represents the dragged element in its new location. To do this, you could create an <a href="/en-US/docs/XUL/image" title="image">image</a> or <a href="/en-US/docs/XUL/separator" title="separator">separator</a> element and insert it into the document during the <code>{{event("dragenter")}}</code> event.</p>

<p>The <code>{{event("dragover")}}</code> event will fire at the element the mouse is pointing at. Naturally, you may need to move the insertion marker around a <code>{{event("dragover")}}</code> event as well. You can use the event's {{domxref("MouseEvent.clientX","clientX")}} and {{domxref("MouseEvent.clientY","clientY")}} properties as with other mouse events to determine the location of the mouse pointer.</p>

<p>Finally, the <code>{{event("dragleave")}}</code> event will fire at an element when the drag leaves the element. This is the time when you should remove any insertion markers or highlighting. You do not need to cancel this event. Any highlighting or other visual effects specified using the <code>:-moz-drag-over</code> pseudoclass will be removed automatically. The <code>{{event("dragleave")}}</code> event will always fire, even if the drag is cancelled, so you can always ensure that any insertion point cleanup can be done during this event.</p>

<h2 id="drop">Performing a Drop</h2>

<p>When the user releases the mouse, the drag and drop operation ends.</p>

<p>If the mouse is released over an element that is a valid drop target, that is, one that cancelled the last <code>{{event("dragenter")}}</code> or <code>{{event("dragover")}}</code> event, then the drop will be successful, and a <code>{{event("drop")}}</code> event will fire at the target. Otherwise, the drag operation is cancelled, and no <code>{{event("drop")}}</code> event is fired.</p>

<p>During the <code>{{event("drop")}}</code> event, you should retrieve that data that was dropped from the event and insert it at the drop location. You can use the {{domxref("DataTransfer.dropEffect","dropEffect")}} property to determine which drag operation was desired.</p>

<p>As with all drag-related events, the event's <code>{{domxref("DataTransfer","dataTransfer")}}</code> property will hold the data that is being dragged. The {{domxref("DataTransfer.getData","getData()")}} method may be used to retrieve the data again.</p>

<pre class="brush: js">function onDrop(event) {
  const data = event.dataTransfer.getData("text/plain");
  event.target.textContent = data;
  event.preventDefault();
}
</pre>

<p>The {{domxref("DataTransfer.getData","getData()")}} method takes one argument, the type of data to retrieve. It will return the string value that was set when {{domxref("DataTransfer.setData","setData()")}} was called at the beginning of the drag operation. An empty string will be returned if data of that type does not exist. (Naturally, though, you would likely know that the right type of data was available, as it was previously checked during a <code>{{event("dragover")}}</code> event.)</p>

<p>In the example here, once the data has been retrieved, we insert the string as the textual content of the target. This has the effect of inserting the dragged text where it was dropped, assuming that the drop target is an area of text such as a <code>p</code> or <code>div</code> element.</p>

<p>In a web page, you should call the {{domxref("Event.preventDefault","preventDefault()")}} method of the event if you have accepted the drop, so that the browser's default handling is not triggered by the dropped data as well. For example, when a link is dragged to a web page, Firefox will open the link. By cancelling the event, this behavior will be prevented.</p>

<p>You can retrieve other types of data as well. If the data is a link, it should have the type <code><a href="/en-US/docs/DragDrop/Recommended_Drag_Types#link" title="text/uri-list">text/uri-list</a></code>. You could then insert a link into the content.</p>

<pre class="brush: js">function doDrop(event) {
  const lines = event.dataTransfer.getData("text/uri-list").split("\n");
  lines.filter(line =&gt; !line.startsWith("#"))
    .forEach(line =&gt; {
      const link = document.createElement("a");
      link.href = line;
      link.textContent = line;
      event.target.appendChild(link);
    })
  event.preventDefault();
}
</pre>

<p>This example inserts a link from the dragged data. As the name implies, the <code><a href="/en-US/docs/DragDrop/Recommended_Drag_Types#link" title="text/uri-list">text/uri-list</a></code> type actually may contain a list of URLs, each on a separate line. The above code uses <code><a href="/en-US/docs/JavaScript/Reference/Global_Objects/String/split" title="split">split</a></code> to break the string into lines, then iterates over the list of lines, and inserts each as a link into the document. (Note also that links starting with a number sign (<code>#</code>) are skipped, as these are comments.)</p>

<p>For simple cases, you can use the special type <code>URL</code> just to retrieve the first valid URL in the list. For example:</p>

<pre class="brush: js">const link = event.dataTransfer.getData("URL");
</pre>

<p>This eliminates the need to check for comments or iterate through lines yourself. However, it is limited to only the first URL in the list.</p>

<p>The <code>URL</code> type is a special type. It is used only as a shorthand, and it does not appear within the list of types specified in the {{domxref("DataTransfer.types","types")}} property.</p>

<p>Sometimes you may support some different formats, and you want to retrieve the data that is most specific that is supported. In the following example, three formats are supported by a drop target.</p>

<p>The following example returns the data associated with the best-supported format:</p>

<pre class="brush: js">function doDrop(event) {
  const supportedTypes = ["application/x-moz-file", "text/uri-list", "text/plain"];
  const types = event.dataTransfer.types.filter(type =&gt; supportedTypes.includes(type));
  if (types.length) {
    const data = event.dataTransfer.getData(types[0]);
  }
  event.preventDefault();
}
</pre>

<h2 id="dragend">Finishing a Drag</h2>

<p>Once the drag is complete, a <code>{{event("dragend")}}</code> event is fired at the source of the drag (the same element that received the <code>{{event("dragstart")}}</code> event). This event will fire if the drag was successful<sup>[1]</sup> or if it was cancelled. However, you can use the {{domxref("DataTransfer.dropEffect","dropEffect")}} property to determine which drop operation occurred.</p>

<p>If the {{domxref("DataTransfer.dropEffect","dropEffect")}} property has the value <code>none</code> during a <code>{{event("dragend")}}</code>, then the drag was cancelled. Otherwise, the effect specifies which operation was performed. The source can use this information after a <code>move</code> operation to remove the dragged item from the old location. The {{domxref("DataTransfer.mozUserCancelled","mozUserCancelled")}} property will be set to <code>true</code> if the user cancelled the drag (by pressing <kbd>Escape</kbd>), and <code>false</code> if the drag was cancelled for other reasons such as an invalid drop target, or if it was successful.</p>

<p>A drop can occur inside the same window or over another application. The <code>{{event("dragend")}}</code> event will always fire regardless. The event's {{domxref("MouseEvent.screenX","screenX")}} and {{domxref("MouseEvent.screenY","screenY")}} properties will be set to the screen coordinates where the drop occurred.</p>

<p>After the <code>{{event("dragend")}}</code> event has finished propagating, the drag and drop operation is complete.</p>

<p>[1]: In Gecko, {{event("dragend")}} is not dispatched if the source node is moved or removed during the drag (e.g. on drop or {{event("dragover")}}). <a class="external" href="https://bugzilla.mozilla.org/show_bug.cgi?id=460801" title="New D&amp;D API: dragend is not dispatched if the source node was moved or removed during the drag session">Bug 460801</a></p>

<h2 id="See_also">See also</h2>

<ul>
	<li><a class="internal" href="/Web/API/HTML_Drag_and_Drop_API" title="HTML Drag and Drop API">HTML Drag and Drop API (Overview)</a></li>
	<li><a class="internal" href="/Web/Guide/HTML/Dragging_and_Dropping_Multiple_Items" title="Dragging and Dropping Multiple Items">Dragging and Dropping Multiple Items</a></li>
	<li><a class="internal" href="/Web/Guide/HTML/Recommended_Drag_Types" title="Recommended Drag Types">Recommended Drag Types</a></li>
	<li><a href="https://html.spec.whatwg.org/multipage/interaction.html#dnd" title="Drag and Drop Standard">HTML5 Living Standard: Drag and Drop</a></li>
</ul>
